Codeforces Round #412 Div. 2 第一场翻水水

大半夜呆在机房做题,我只感觉智商严重下降,今天我脑子可能不太正常

A. Is it rated?
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Is it rated?

Here it is. The Ultimate Question of Competitive Programming, Codeforces, and Everything. And you are here to answer it.

Another Codeforces round has been conducted. No two participants have the same number of points. For each participant, from the top to the bottom of the standings, their rating before and after the round is known.

It's known that if at least one participant's rating has changed, then the round was rated for sure.

It's also known that if the round was rated and a participant with lower rating took a better place in the standings than a participant with higher rating, then at least one round participant's rating has changed.

In this problem, you should not make any other assumptions about the rating system.

Determine if the current round is rated, unrated, or it's impossible to determine whether it is rated of not.

Input

The first line contains a single integer n (2 ≤ n ≤ 1000) — the number of round participants.

Each of the next n lines contains two integers ai and bi (1 ≤ ai, bi ≤ 4126) — the rating of the i-th participant before and after the round, respectively. The participants are listed in order from the top to the bottom of the standings.

Output

If the round is rated for sure, print "rated". If the round is unrated for sure, print "unrated". If it's impossible to determine whether the round is rated or not, print "maybe".

Examples
input
6
3060 3060
2194 2194
2876 2903
2624 2624
3007 2991
2884 2884
output
rated
input
4
1500 1500
1300 1300
1200 1200
1400 1400
output
unrated
input
5
3123 3123
2777 2777
2246 2246
2246 2246
1699 1699
output
maybe
Note

In the first example, the ratings of the participants in the third and fifth places have changed, therefore, the round was rated.

In the second example, no one's rating has changed, but the participant in the second place has lower rating than the participant in the fourth place. Therefore, if the round was rated, someone's rating would've changed for sure.

In the third example, no one's rating has changed, and the participants took places in non-increasing order of their rating. Therefore, it's impossible to determine whether the round is rated or not.

这是大水题,问你有没有rated,题目意思说得很清楚啊,这不是要很快就能做出来的么,可是我wa了,打错了赋值,可是测试数据又对,调调调,还不如再打一遍嘛,这个wa我服

#include <bits/stdc++.h>
using namespace std;
int main(){
int n;
cin>>n;
int f=0,f1=0;
int t1,t2;
n--;
scanf("%d%d",&t1,&t2);
if(t1!=t2)
f=1;
while(n--){
    int a,b;
    scanf("%d%d",&a,&b);
    if(a!=b)
    f=1;
    else if(a>t1)
    f1=1;
    t1=a;
}
if(f)cout<<"rated";
else if(f1)cout<<"unrated";
else cout<<"maybe";
return 0;
}
B. T-Shirt Hunt
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Not so long ago the Codecraft-17 contest was held on Codeforces. The top 25 participants, and additionally random 25 participants out of those who got into top 500, will receive a Codeforces T-shirt.

Unfortunately, you didn't manage to get into top 25, but you got into top 500, taking place p.

Now the elimination round of 8VC Venture Cup 2017 is being held. It has been announced that the Codecraft-17 T-shirt winners will be chosen as follows. Let s be the number of points of the winner of the elimination round of 8VC Venture Cup 2017. Then the following pseudocode will be executed:


i := (s div 50) mod 475
repeat 25 times:
i := (i * 96 + 42) mod 475
print (26 + i)

Here "div" is the integer division operator, "mod" is the modulo (the remainder of division) operator.

As the result of pseudocode execution, 25 integers between 26 and 500, inclusive, will be printed. These will be the numbers of places of the participants who get the Codecraft-17 T-shirts. It is guaranteed that the 25 printed integers will be pairwise distinct for any value of s.

You're in the lead of the elimination round of 8VC Venture Cup 2017, having x points. You believe that having at least y points in the current round will be enough for victory.

To change your final score, you can make any number of successful and unsuccessful hacks. A successful hack brings you 100 points, an unsuccessful one takes 50 points from you. It's difficult to do successful hacks, though.

You want to win the current round and, at the same time, ensure getting a Codecraft-17 T-shirt. What is the smallest number of successful hacks you have to do to achieve that?

Input

The only line contains three integers px and y (26 ≤ p ≤ 500; 1 ≤ y ≤ x ≤ 20000) — your place in Codecraft-17, your current score in the elimination round of 8VC Venture Cup 2017, and the smallest number of points you consider sufficient for winning the current round.

Output

Output a single integer — the smallest number of successful hacks you have to do in order to both win the elimination round of 8VC Venture Cup 2017 and ensure getting a Codecraft-17 T-shirt.

It's guaranteed that your goal is achievable for any valid input data.

Examples
input
239 10880 9889
output
0
input
26 7258 6123
output
2
input
493 8000 8000
output
24
input
101 6800 6500
output
0
input
329 19913 19900
output
8
Note

In the first example, there is no need to do any hacks since 10880 points already bring the T-shirt to the 239-th place of Codecraft-17 (that is, you). In this case, according to the pseudocode, the T-shirts will be given to the participants at the following places:


475 422 84 411 453 210 157 294 146 188 420 367 29 356 398 155 102 239 91 133 365 312 449 301 343

In the second example, you have to do two successful and one unsuccessful hack to make your score equal to 7408.

In the third example, you need to do as many as 24 successful hacks to make your score equal to 10400.

In the fourth example, it's sufficient to do 6 unsuccessful hacks (and no successful ones) to make your score equal to 6500, which is just enough for winning the current round and also getting the T-shirt.

B题这个意思也太难理解了吧,服服服,可能是给外国人做的,反正就是找一个分数估算名次,进行循环控制名次,名次有了就看看是对了几道题

#include <bits/stdc++.h>
using namespace std;
int main(){
int p,x,y;
scanf("%d%d%d",&p,&x,&y);
int a[26];
if(y<x){
    for(int j=x;j>=y;j-=50){
    int f=(j/50)%475;
    for(int i=0;i<25;i++){
    f=(f*96+42)%475;
    a[i]=f+26;
    if(a[i]==p&&j>=y){printf("0");return 0;}
}}}
for(int j=x;;j+=50){
int f=(j/50)%475;
for(int i=0;i<25;i++){
    f=(f*96+42)%475;
    a[i]=f+26;
    if(a[i]==p){printf("%d",(j+50-x)/100);return 0;}
}}


return 0;
}
C. Success Rate
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

You are an experienced Codeforces user. Today you found out that during your activity on Codeforces you have made ysubmissions, out of which x have been successful. Thus, your current success rate on Codeforces is equal to x / y.

Your favorite rational number in the [0;1] range is p / q. Now you wonder: what is the smallest number of submissions you have to make if you want your success rate to be p / q?

Input

The first line contains a single integer t (1 ≤ t ≤ 1000) — the number of test cases.

Each of the next t lines contains four integers xyp and q (0 ≤ x ≤ y ≤ 109; 0 ≤ p ≤ q ≤ 109; y > 0; q > 0).

It is guaranteed that p / q is an irreducible fraction.

Hacks. For hacks, an additional constraint of t ≤ 5 must be met.

Output

For each test case, output a single integer equal to the smallest number of submissions you have to make if you want your success rate to be equal to your favorite rational number, or -1 if this is impossible to achieve.

Example
input
4
3 10 1 2
7 14 3 8
20 70 2 7
5 6 1 1
output
4
10
0
-1
Note

In the first example, you have to make 4 successful submissions. Your success rate will be equal to 7 / 14, or 1 / 2.

In the second example, you have to make 2 successful and 8 unsuccessful submissions. Your success rate will be equal to 9 / 24, or 3 / 8.

In the third example, there is no need to make any new submissions. Your success rate is already equal to 20 / 70, or 2 / 7.

In the fourth example, the only unsuccessful submission breaks your hopes of having the success rate equal to 1.

 

C我想了一箩筐的东西,都没AC啊,一直卡test2,其实test2就是一个比较大的样例吧,我想用扩展欧几里得算法做,可是跪了,有些东西我并不是很清楚可能,哎哎哎,赛后我看有人这样过的。我之后在想二分的做法,还是跪了,样例都不对,看了别人的二分才发现自己推错公式了

#include<bits/stdc++.h>
using namespace std;
int main(){
    int t;
    scanf("%d",&t);
    while(t--){
        long long a,b,p,q;
        long long t,t2;
        scanf("%lld%lld%lld%lld",&a,&b,&p,&q);
        if(!p&&!a){
            puts("0");
            continue;
        }
        else if(!p){
            puts("-1");
            continue;
        }
        t=(a+p-1)/p;
        t2=(b+q-1)/q;
        long long s=0,e=1<<30,m,ans=e;
        bool f=0;
        s=max(t,t2);
        while(s<=e){
            m=(s+e)/2;
            if(m*q-b>=m*p-a){
                ans=m*q-b;
                e=m-1;
                f=1;
            }
            else s=m+1;

        }
        if(f)printf("%lld\n",ans);
        else puts("-1");
    }
}

扎铁了,老心,才两题从0开始,希望rating可以涨涨,颜色可以深点

posted @ 2017-05-08 05:13  暴力都不会的蒟蒻  阅读(1154)  评论(0编辑  收藏  举报